from __future__ import annotations
from typing import Any
from enum import IntEnum
from enum import auto

class FadeEffect(IntEnum):
    NONE = auto()
    FADE_FROM_LEFT = auto()
    FADE_FROM_TOP = auto()
    FADE_FROM_RIGHT = auto()
    FADE_FROM_BOTTOM = auto()
    FADE_TO_CENTER = auto()
    FADE_FROM_CENTER = auto()
    MOVE_FROM_LEFT = auto()
    MOVE_FROM_TOP = auto()
    MOVE_FROM_RIGHT = auto()
    MOVE_FROM_BOTTOM = auto()
    ROLL_FROM_LEFT = auto()
    ROLL_FROM_TOP = auto()
    ROLL_FROM_RIGHT = auto()
    ROLL_FROM_BOTTOM = auto()
    VERTICAL_STRIPES = auto()
    HORIZONTAL_STRIPES = auto()
    CLOCKWISE = auto()
    COUNTERCLOCKWISE = auto()
    FADE_FROM_UPPERLEFT = auto()
    FADE_FROM_UPPERRIGHT = auto()
    FADE_FROM_LOWERLEFT = auto()
    FADE_FROM_LOWERRIGHT = auto()
    CLOSE_VERTICAL = auto()
    CLOSE_HORIZONTAL = auto()
    OPEN_VERTICAL = auto()
    OPEN_HORIZONTAL = auto()
    SPIRALIN_LEFT = auto()
    SPIRALIN_RIGHT = auto()
    SPIRALOUT_LEFT = auto()
    SPIRALOUT_RIGHT = auto()
    DISSOLVE = auto()
    WAVYLINE_FROM_LEFT = auto()
    WAVYLINE_FROM_TOP = auto()
    WAVYLINE_FROM_RIGHT = auto()
    WAVYLINE_FROM_BOTTOM = auto()
    RANDOM = auto()
    STRETCH_FROM_LEFT = auto()
    STRETCH_FROM_TOP = auto()
    STRETCH_FROM_RIGHT = auto()
    STRETCH_FROM_BOTTOM = auto()
    VERTICAL_LINES = auto()
    HORIZONTAL_LINES = auto()
    MOVE_FROM_UPPERLEFT = auto()
    MOVE_FROM_UPPERRIGHT = auto()
    MOVE_FROM_LOWERRIGHT = auto()
    MOVE_FROM_LOWERLEFT = auto()
    UNCOVER_TO_LEFT = auto()
    UNCOVER_TO_UPPERLEFT = auto()
    UNCOVER_TO_TOP = auto()
    UNCOVER_TO_UPPERRIGHT = auto()
    UNCOVER_TO_RIGHT = auto()
    UNCOVER_TO_LOWERRIGHT = auto()
    UNCOVER_TO_BOTTOM = auto()
    UNCOVER_TO_LOWERLEFT = auto()
    VERTICAL_CHECKERBOARD = auto()
    HORIZONTAL_CHECKERBOARD = auto()
